"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[22092],{81756:(e,n,t)=>{t.r(n),t.d(n,{assets:()=>l,contentTitle:()=>r,default:()=>u,frontMatter:()=>o,metadata:()=>a,toc:()=>c});var s=t(85893),i=t(11151);const o={},r="Models",a={id:"blueprints/v1/models",title:"Models",description:"Some models behave differently and allow for access to different API fields when created via blueprint.",source:"@site/developer-docs/blueprints/v1/models.md",sourceDirName:"blueprints/v1",slug:"/blueprints/v1/models",permalink:"/developer-docs/blueprints/v1/models",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/developer-docs/blueprints/v1/models.md",tags:[],version:"current",frontMatter:{},sidebar:"docs",previous:{title:"Example",permalink:"/developer-docs/blueprints/v1/example"},next:{title:"Meta models",permalink:"/developer-docs/blueprints/v1/meta"}},l={},c=[{value:"<code>authentik_core.token</code>",id:"authentik_coretoken",level:3},{value:"<code>authentik_core.user</code>",id:"authentik_coreuser",level:3},{value:"<code>authentik_core.application</code>",id:"authentik_coreapplication",level:3},{value:"<code>authentik_sources_oauth.oauthsource</code>, <code>authentik_sources_saml.samlsource</code>, <code>authentik_sources_plex.plexsource</code>",id:"authentik_sources_oauthoauthsource-authentik_sources_samlsamlsource-authentik_sources_plexplexsource",level:3},{value:"<code>authentik_flows.flow</code>",id:"authentik_flowsflow",level:3}];function d(e){const n={admonition:"admonition",code:"code",h1:"h1",h3:"h3",p:"p",pre:"pre",...(0,i.a)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)(n.h1,{id:"models",children:"Models"}),"\n",(0,s.jsx)(n.p,{children:"Some models behave differently and allow for access to different API fields when created via blueprint."}),"\n",(0,s.jsx)(n.h3,{id:"authentik_coretoken",children:(0,s.jsx)(n.code,{children:"authentik_core.token"})}),"\n",(0,s.jsx)(n.admonition,{type:"info",children:(0,s.jsx)(n.p,{children:"Requires authentik 2023.4"})}),"\n",(0,s.jsx)(n.p,{children:"Via the standard API, a token's key cannot be changed, it can only be rotated. This is to ensure a high entropy in it's key, and to prevent insecure data from being used. However, when provisioning tokens via a blueprint, it may be required to set a token to an existing value."}),"\n",(0,s.jsxs)(n.p,{children:["With blueprints, the field ",(0,s.jsx)(n.code,{children:"key"})," can be set, to set the token's key to any value."]}),"\n",(0,s.jsx)(n.p,{children:"For example:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-yaml",children:"# [...]\n- model: authentik_core.token\n  state: present\n  identifiers:\n      identifier: my-token\n  attrs:\n      key: this-should-be-a-long-value\n      user: !KeyOf my-user\n      intent: api\n"})}),"\n",(0,s.jsx)(n.h3,{id:"authentik_coreuser",children:(0,s.jsx)(n.code,{children:"authentik_core.user"})}),"\n",(0,s.jsx)(n.admonition,{type:"info",children:(0,s.jsx)(n.p,{children:"Requires authentik 2023.6"})}),"\n",(0,s.jsxs)(n.p,{children:["Via the standard API, a user's password can only be set via the separate ",(0,s.jsx)(n.code,{children:"/api/v3/core/users/<id>/set_password/"})," endpoint. In blueprints, the password of a user can be set using the ",(0,s.jsx)(n.code,{children:"password"})," field."]}),"\n",(0,s.jsx)(n.p,{children:"Keep in mind that if an LDAP\xa0Source is configured and the user maps to an LDAP user, this password change will be propagated to the LDAP server."}),"\n",(0,s.jsx)(n.p,{children:"For example:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-yaml",children:"# [...]\n- model: authentik_core.user\n  state: present\n  identifiers:\n      username: test-user\n  attrs:\n      name: test user\n      password: this-should-be-a-long-value\n"})}),"\n",(0,s.jsx)(n.h3,{id:"authentik_coreapplication",children:(0,s.jsx)(n.code,{children:"authentik_core.application"})}),"\n",(0,s.jsx)(n.admonition,{type:"info",children:(0,s.jsx)(n.p,{children:"Requires authentik 2023.5"})}),"\n",(0,s.jsxs)(n.p,{children:["Application icons can be directly set to URLs with the ",(0,s.jsx)(n.code,{children:"icon"})," field."]}),"\n",(0,s.jsx)(n.p,{children:"For example:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-yaml",children:"# [...]\n- model: authentik_core.application\n  identifiers:\n      slug: my-app\n  attrs:\n      name: My App\n      icon: https://goauthentik.io/img/icon.png\n"})}),"\n",(0,s.jsxs)(n.h3,{id:"authentik_sources_oauthoauthsource-authentik_sources_samlsamlsource-authentik_sources_plexplexsource",children:[(0,s.jsx)(n.code,{children:"authentik_sources_oauth.oauthsource"}),", ",(0,s.jsx)(n.code,{children:"authentik_sources_saml.samlsource"}),", ",(0,s.jsx)(n.code,{children:"authentik_sources_plex.plexsource"})]}),"\n",(0,s.jsx)(n.admonition,{type:"info",children:(0,s.jsx)(n.p,{children:"Requires authentik 2023.5"})}),"\n",(0,s.jsxs)(n.p,{children:["Source icons can be directly set to URLs with the ",(0,s.jsx)(n.code,{children:"icon"})," field."]}),"\n",(0,s.jsx)(n.p,{children:"For example:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-yaml",children:"# [...]\n- model: authentik_sources_oauth.oauthsource\n  identifiers:\n      slug: my-source\n  attrs:\n      name: My source\n      icon: https://goauthentik.io/img/icon.png\n"})}),"\n",(0,s.jsx)(n.h3,{id:"authentik_flowsflow",children:(0,s.jsx)(n.code,{children:"authentik_flows.flow"})}),"\n",(0,s.jsx)(n.admonition,{type:"info",children:(0,s.jsx)(n.p,{children:"Requires authentik 2023.5"})}),"\n",(0,s.jsxs)(n.p,{children:["Flow backgrounds can be directly set to URLs with the ",(0,s.jsx)(n.code,{children:"background"})," field."]}),"\n",(0,s.jsx)(n.p,{children:"For example:"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-yaml",children:"# [...]\n- model: authentik_flows.flow\n  identifiers:\n      slug: my-flow\n  attrs:\n      name: my-flow\n      title: My flow\n      designation: authentication\n      background: https://goauthentik.io/img/icon.png\n"})})]})}function u(e={}){const{wrapper:n}={...(0,i.a)(),...e.components};return n?(0,s.jsx)(n,{...e,children:(0,s.jsx)(d,{...e})}):d(e)}}}]);