"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[19431],{62233:(e,i,n)=>{n.r(i),n.d(i,{assets:()=>l,contentTitle:()=>r,default:()=>p,frontMatter:()=>o,metadata:()=>a,toc:()=>c});var t=n(85893),s=n(11151);const o={title:"MinIO"},r=void 0,a={id:"services/minio/index",title:"MinIO",description:"Support level: authentik",source:"@site/integrations/services/minio/index.md",sourceDirName:"services/minio",slug:"/services/minio/",permalink:"/integrations/services/minio/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/integrations/services/minio/index.md",tags:[],version:"current",frontMatter:{title:"MinIO"},sidebar:"integrations",previous:{title:"Jenkins",permalink:"/integrations/services/jenkins/"},next:{title:"NetBox",permalink:"/integrations/services/netbox/"}},l={},c=[{value:"What is MinIO",id:"what-is-minio",level:2},{value:"Preparation",id:"preparation",level:2},{value:"Mapping to MinIO policies",id:"mapping-to-minio-policies",level:3},{value:"Creating application and provider",id:"creating-application-and-provider",level:3},{value:"MinIO",id:"minio",level:2}];function d(e){const i={a:"a",blockquote:"blockquote",code:"code",em:"em",h2:"h2",h3:"h3",li:"li",p:"p",pre:"pre",ul:"ul",...(0,s.a)(),...e.components};return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsx)("span",{class:"badge badge--primary",children:"Support level: authentik"}),"\n",(0,t.jsx)(i.h2,{id:"what-is-minio",children:"What is MinIO"}),"\n",(0,t.jsxs)(i.blockquote,{children:["\n",(0,t.jsx)(i.p,{children:"MinIO is an Amazon S3 compatible object storage suite capable of handling structured and unstructured data including log files, artifacts, backups, container images, photos and videos. The current maximum supported object size is 5TB."}),"\n",(0,t.jsxs)(i.p,{children:["-- ",(0,t.jsx)(i.a,{href:"https://en.wikipedia.org/wiki/MinIO",children:"https://en.wikipedia.org/wiki/MinIO"})]}),"\n"]}),"\n",(0,t.jsx)(i.h2,{id:"preparation",children:"Preparation"}),"\n",(0,t.jsx)(i.p,{children:"The following placeholders will be used:"}),"\n",(0,t.jsxs)(i.ul,{children:["\n",(0,t.jsxs)(i.li,{children:[(0,t.jsx)(i.code,{children:"minio.company"})," is the FQDN of the MinIO install."]}),"\n",(0,t.jsxs)(i.li,{children:[(0,t.jsx)(i.code,{children:"authentik.company"})," is the FQDN of the authentik install."]}),"\n"]}),"\n",(0,t.jsx)(i.h3,{id:"mapping-to-minio-policies",children:"Mapping to MinIO policies"}),"\n",(0,t.jsxs)(i.p,{children:["The primary way to manage access in MinIO is via ",(0,t.jsx)(i.a,{href:"https://min.io/docs/minio/linux/administration/identity-access-management/policy-based-access-control.html#minio-policy",children:"policies"}),". We need to configure authentik to return a list of which MinIO policies should be applied to a user."]}),"\n",(0,t.jsxs)(i.p,{children:["Under ",(0,t.jsx)(i.em,{children:"Customization"})," -> ",(0,t.jsx)(i.em,{children:"Property Mappings"}),", create a ",(0,t.jsx)(i.em,{children:"Scope Mapping"}),'. Give it a name like "OIDC-Scope-minio". Set the scope name to ',(0,t.jsx)(i.code,{children:"minio"})," and the expression to the following"]}),"\n",(0,t.jsx)(i.pre,{children:(0,t.jsx)(i.code,{className:"language-python",children:'return {\n    "policy": "readwrite",\n}\n'})}),"\n",(0,t.jsxs)(i.p,{children:["This mapping will result in the default MinIO ",(0,t.jsx)(i.code,{children:"readwrite"})," policy being applied to all users. If you want to create a more granular mapping based on authentik groups, use an expression like this"]}),"\n",(0,t.jsx)(i.pre,{children:(0,t.jsx)(i.code,{className:"language-python",children:'if ak_is_group_member(request.user, name="Minio admins"):\n  return {\n      "policy": "consoleAdmin",\n}\nelif ak_is_group_member(request.user, name="Minio users"):\n  return {\n      "policy": ["readonly", "my-custom-policy"]\n}\nreturn None\n'})}),"\n",(0,t.jsxs)(i.p,{children:["Note that you can assign multiple policies to a user by returning a list, and returning ",(0,t.jsx)(i.code,{children:"None"})," will map no policies to the user, resulting in no access to the MinIO instance. For more information on writing expressions, see ",(0,t.jsx)(i.a,{href:"../../../docs/property-mappings/expression",children:"Expressions"})," and ",(0,t.jsx)(i.a,{href:"../../../docs/user-group-role/user/user_ref#object-properties",children:"User"})," docs."]}),"\n",(0,t.jsx)(i.h3,{id:"creating-application-and-provider",children:"Creating application and provider"}),"\n",(0,t.jsxs)(i.p,{children:["Create an application in authentik. Create an ",(0,t.jsx)(i.em,{children:"OAuth2/OpenID Provider"})," with the following parameters:"]}),"\n",(0,t.jsxs)(i.ul,{children:["\n",(0,t.jsxs)(i.li,{children:["Client Type: ",(0,t.jsx)(i.code,{children:"Confidential"})]}),"\n",(0,t.jsx)(i.li,{children:"Scopes: OpenID, Email, Profile and the scope you created above"}),"\n",(0,t.jsx)(i.li,{children:"Signing Key: Select any available key"}),"\n",(0,t.jsxs)(i.li,{children:["Redirect URIs: ",(0,t.jsx)(i.code,{children:"https://minio.company/oauth_callback"})]}),"\n"]}),"\n",(0,t.jsx)(i.p,{children:"Note the Client ID and Client Secret values. Create an application, using the provider you've created above. Note the slug of the application you've created."}),"\n",(0,t.jsx)(i.h2,{id:"minio",children:"MinIO"}),"\n",(0,t.jsx)(i.pre,{children:(0,t.jsx)(i.code,{children:'~ mc admin config set myminio identity_openid \\\n  config_url="https://authentik.company/application/o/<applicaiton-slug>/.well-known/openid-configuration" \\\n  client_id="<client id from above>" \\\n  client_secret="<client secret from above>" \\\n  scopes="openid,profile,email,minio"\n'})}),"\n",(0,t.jsxs)(i.p,{children:["The ",(0,t.jsx)(i.a,{href:"https://min.io/docs/minio/linux/reference/minio-mc-admin/mc-admin-config.html#openid-identity-management",children:"upstream MinIO docs on OIDC"})," indicate that the ",(0,t.jsx)(i.code,{children:"client_secret"})," (and thus confidential client type) are optional depending on provider. Experimentally with a single-node MinIO instance, the client secret was required and worked without further issue."]})]})}function p(e={}){const{wrapper:i}={...(0,s.a)(),...e.components};return i?(0,t.jsx)(i,{...e,children:(0,t.jsx)(d,{...e})}):d(e)}}}]);