"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[64512],{61575:(e,t,i)=>{i.r(t),i.d(t,{assets:()=>r,contentTitle:()=>o,default:()=>h,frontMatter:()=>a,metadata:()=>d,toc:()=>c});var s=i(85893),n=i(11151);const a={title:"Flow Context"},o=void 0,d={id:"flow/context/index",title:"Flow Context",description:"Each flow execution has an independent context. This context holds all of the arbitrary data about that specific flow, data which can then be used and transformed by stages and policies.",source:"@site/docs/flow/context/index.md",sourceDirName:"flow/context",slug:"/flow/context/",permalink:"/docs/flow/context/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/flow/context/index.md",tags:[],version:"current",frontMatter:{title:"Flow Context"},sidebar:"docs",previous:{title:"Flow Inspector",permalink:"/docs/flow/inspector"},next:{title:"Example Flows",permalink:"/docs/flow/examples/flows"}},r={},c=[{value:"Managing data in a flow context",id:"managing-data-in-a-flow-context",level:2},{value:"Context dictionary and reserved keys",id:"context-dictionary-and-reserved-keys",level:2},{value:"Common keys",id:"common-keys",level:3},{value:"<code>pending_user</code> (User object)",id:"pending_user-user-object",level:4},{value:"<code>prompt_data</code> (Dictionary)",id:"prompt_data-dictionary",level:4},{value:"<code>redirect</code> (string)",id:"redirect-string",level:4},{value:"<code>pending_user_identifier</code> (string)",id:"pending_user_identifier-string",level:4},{value:"<code>application</code> (Application object)",id:"application-application-object",level:4},{value:"<code>source</code> (Source object)",id:"source-source-object",level:4},{value:"Scenario-specific keys",id:"scenario-specific-keys",level:3},{value:"<code>is_sso</code> (boolean)",id:"is_sso-boolean",level:4},{value:"<code>is_restored</code> (Token object)",id:"is_restored-token-object",level:4},{value:"Stage-specific keys",id:"stage-specific-keys",level:3},{value:"Autosubmit stage",id:"autosubmit-stage",level:4},{value:"<code>title</code> (string)",id:"title-string",level:5},{value:"<code>url</code> (string)",id:"url-string",level:5},{value:"<code>attrs</code> (dictionary)",id:"attrs-dictionary",level:5},{value:"Captcha stage",id:"captcha-stage",level:4},{value:"<code>captcha</code> (dictionary)",id:"captcha-dictionary",level:5},{value:"Consent stage",id:"consent-stage",level:4},{value:"<code>consent_header</code> (string)",id:"consent_header-string",level:5},{value:"<code>consent_permissions</code> (List of PermissionDict)",id:"consent_permissions-list-of-permissiondict",level:5},{value:"Deny stage",id:"deny-stage",level:4},{value:"<code>deny_message</code> (string)",id:"deny_message-string",level:5},{value:"User write stage",id:"user-write-stage",level:4},{value:"<code>groups</code> (List of Group objects)",id:"groups-list-of-group-objects",level:5},{value:"<code>user_path</code> (string)",id:"user_path-string",level:5},{value:"<code>user_type</code> (string)",id:"user_type-string",level:5},{value:"Password stage",id:"password-stage",level:4},{value:"<code>user_backend</code> (string)",id:"user_backend-string",level:5},{value:"<code>auth_method</code> (string)",id:"auth_method-string",level:5},{value:"<code>auth_method_args</code> (dictionary)",id:"auth_method_args-dictionary",level:5},{value:"Email stage",id:"email-stage",level:4},{value:"<code>email_sent</code> (boolean)",id:"email_sent-boolean",level:5},{value:"<code>email</code> (string)",id:"email-string",level:5},{value:"Identification stage",id:"identification-stage",level:4},{value:"<code>pending_user_identifier</code> (string)",id:"pending_user_identifier-string-1",level:5}];function l(e){const t={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h3:"h3",h4:"h4",h5:"h5",li:"li",p:"p",pre:"pre",ul:"ul",...(0,n.a)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsxs)(t.p,{children:["Each flow execution has an independent ",(0,s.jsx)(t.em,{children:"context"}),". This context holds all of the arbitrary data about that specific flow, data which can then be used and transformed by stages and policies."]}),"\n",(0,s.jsx)(t.h2,{id:"managing-data-in-a-flow-context",children:"Managing data in a flow context"}),"\n",(0,s.jsx)(t.p,{children:"You create and manage the data for a context by configuring policies, stages, and bindings. As you plan your flow, and set up the required stages, etc. you are creating the context data for that flow."}),"\n",(0,s.jsx)(t.p,{children:"For example, in the Identification Stage (part of the default login flow), you can define whether users will be prompted to enter an email address, a username, or both. All such information about the flow's configuration makes up the context."}),"\n",(0,s.jsx)(t.p,{children:"Any data can be stored in the flow context, however there are some reserved keys in the context dictionary that are used by authentik stages."}),"\n",(0,s.jsx)(t.h2,{id:"context-dictionary-and-reserved-keys",children:"Context dictionary and reserved keys"}),"\n",(0,s.jsx)(t.p,{children:"This section describes the data (the context) that are used in authentik, and provides a list of keys, what they are used for and when they are set."}),"\n",(0,s.jsx)(t.admonition,{type:"warning",children:(0,s.jsxs)(t.p,{children:["Keys prefixed with ",(0,s.jsx)(t.code,{children:"goauthentik.io"})," are used internally by authentik and are subject to change without notice, and should not be modified in policies in most cases."]})}),"\n",(0,s.jsx)(t.h3,{id:"common-keys",children:"Common keys"}),"\n",(0,s.jsxs)(t.h4,{id:"pending_user-user-object",children:[(0,s.jsx)(t.code,{children:"pending_user"})," (",(0,s.jsx)(t.a,{href:"/docs/user-group-role/user/user_ref#object-properties",children:"User object"}),")"]}),"\n",(0,s.jsxs)(t.p,{children:[(0,s.jsx)(t.code,{children:"pending_user"})," is used by multiple stages. In the context of most flow executions, it represents the data of the user that is executing the flow. This value is not set automatically, it is set via the ",(0,s.jsx)(t.a,{href:"../stages/identification/",children:"Identification stage"}),"."]}),"\n",(0,s.jsxs)(t.p,{children:["Stages that require a user, such as the ",(0,s.jsx)(t.a,{href:"../stages/password/",children:"Password stage"}),", the ",(0,s.jsx)(t.a,{href:"../stages/authenticator_validate/",children:"Authenticator validation stage"})," and others will use this value if it is set, and fallback to the request's users when possible."]}),"\n",(0,s.jsxs)(t.h4,{id:"prompt_data-dictionary",children:[(0,s.jsx)(t.code,{children:"prompt_data"})," (Dictionary)"]}),"\n",(0,s.jsxs)(t.p,{children:[(0,s.jsx)(t.code,{children:"prompt_data"})," is primarily used by the ",(0,s.jsx)(t.a,{href:"../stages/prompt/",children:"Prompt stage"}),". The value of any field within a prompt stage is written to the ",(0,s.jsx)(t.code,{children:"prompt_data"})," dictionary. For example, given a field with the ",(0,s.jsx)(t.em,{children:"Field key"})," ",(0,s.jsx)(t.code,{children:"email"})," that was submitted with the value ",(0,s.jsx)(t.code,{children:"foo@bar.baz"})," will result in the following context:"]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-json",children:'{\n    "prompt_data": {\n        "email": "foo@bar.baz"\n    }\n}\n'})}),"\n",(0,s.jsxs)(t.p,{children:["This data can be modified with policies. The data is also used by stages like ",(0,s.jsx)(t.a,{href:"/docs/flow/stages/user_write",children:"User write"}),", which takes data in ",(0,s.jsx)(t.code,{children:"prompt_data"})," and writes it to ",(0,s.jsx)(t.code,{children:"pending_user"}),"."]}),"\n",(0,s.jsxs)(t.h4,{id:"redirect-string",children:[(0,s.jsx)(t.code,{children:"redirect"})," (string)"]}),"\n",(0,s.jsx)(t.p,{children:"Stores the final redirect URL that the user's browser will be sent to after the flow is finished executing successfully. This is set when an un-authenticated user attempts to access a secured application, and when a user authenticates/enrolls with an external source."}),"\n",(0,s.jsxs)(t.h4,{id:"pending_user_identifier-string",children:[(0,s.jsx)(t.code,{children:"pending_user_identifier"})," (string)"]}),"\n",(0,s.jsxs)(t.p,{children:["If ",(0,s.jsx)(t.em,{children:"Show matched user"})," is disabled, this key will hold the user identifier entered by the user in the identification stage."]}),"\n",(0,s.jsx)(t.p,{children:"Stores the final redirect URL that the user's browser will be sent to after the flow is finished executing successfully. This is set when an un-authenticated user attempts to access a secured application, and when a user authenticates/enrolls with an external source."}),"\n",(0,s.jsxs)(t.h4,{id:"application-application-object",children:[(0,s.jsx)(t.code,{children:"application"})," (Application object)"]}),"\n",(0,s.jsxs)(t.p,{children:["When an unauthenticated user attempts to access a secured resource, they are redirected to an authentication flow. The application they attempted to access will be stored in the key attached to this object. For example: ",(0,s.jsx)(t.code,{children:"application.github"}),", with ",(0,s.jsx)(t.code,{children:"application"})," being the key and ",(0,s.jsx)(t.code,{children:"github"})," the value."]}),"\n",(0,s.jsxs)(t.h4,{id:"source-source-object",children:[(0,s.jsx)(t.code,{children:"source"})," (Source object)"]}),"\n",(0,s.jsx)(t.p,{children:"When a user authenticates/enrolls via an external source, this will be set to the source they are using."}),"\n",(0,s.jsx)(t.h3,{id:"scenario-specific-keys",children:"Scenario-specific keys"}),"\n",(0,s.jsxs)(t.h4,{id:"is_sso-boolean",children:[(0,s.jsx)(t.code,{children:"is_sso"})," (boolean)"]}),"\n",(0,s.jsxs)(t.p,{children:["Set to ",(0,s.jsx)(t.code,{children:"True"}),' when the flow is executed from an "SSO" context. For example, this is set when a flow is used during the authentication or enrollment via an external source, and if a flow is executed to authorize access to an application.']}),"\n",(0,s.jsxs)(t.h4,{id:"is_restored-token-object",children:[(0,s.jsx)(t.code,{children:"is_restored"})," (Token object)"]}),"\n",(0,s.jsxs)(t.p,{children:["Set when a flow execution is continued from a token. This happens for example when an ",(0,s.jsx)(t.a,{href:"/docs/flow/stages/email/",children:"Email stage"})," is used and the user clicks on the link within the email. The token object contains the key that was used to restore the flow execution."]}),"\n",(0,s.jsx)(t.h3,{id:"stage-specific-keys",children:"Stage-specific keys"}),"\n",(0,s.jsx)(t.h4,{id:"autosubmit-stage",children:"Autosubmit stage"}),"\n",(0,s.jsx)(t.p,{children:"The autosubmit stage is an internal stage type that is not configurable via the API/Web interface. It is used in certain situations, where a POST request is sent from the browser, such as with SAML POST bindings. This works by using an HTML form that is submitted automatically."}),"\n",(0,s.jsxs)(t.h5,{id:"title-string",children:[(0,s.jsx)(t.code,{children:"title"})," (string)"]}),"\n",(0,s.jsx)(t.p,{children:"Optional title of the form shown to the user. Automatically set when this stage is used by the backend."}),"\n",(0,s.jsxs)(t.h5,{id:"url-string",children:[(0,s.jsx)(t.code,{children:"url"})," (string)"]}),"\n",(0,s.jsx)(t.p,{children:"URL that the form will be submitted to."}),"\n",(0,s.jsxs)(t.h5,{id:"attrs-dictionary",children:[(0,s.jsx)(t.code,{children:"attrs"})," (dictionary)"]}),"\n",(0,s.jsxs)(t.p,{children:["Key-value pairs of the data that is included in the form and will be submitted to ",(0,s.jsx)(t.code,{children:"url"}),"."]}),"\n",(0,s.jsx)(t.h4,{id:"captcha-stage",children:"Captcha stage"}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsx)(t.p,{children:"Requires authentik 2024.6"})}),"\n",(0,s.jsxs)(t.h5,{id:"captcha-dictionary",children:[(0,s.jsx)(t.code,{children:"captcha"})," (dictionary)"]}),"\n",(0,s.jsxs)(t.p,{children:["When ",(0,s.jsx)(t.code,{children:"error_on_invalid_score"})," (TODO) is set to false on a captcha stage, after the execution of the captcha stage, this object will be set in the flow context."]}),"\n",(0,s.jsxs)(t.p,{children:["It contains two keys, ",(0,s.jsx)(t.code,{children:"response"})," which is the raw response from the specified captcha verification URL, and ",(0,s.jsx)(t.code,{children:"stage"}),", which is a reference to the captcha stage that executed the test."]}),"\n",(0,s.jsx)(t.h4,{id:"consent-stage",children:"Consent stage"}),"\n",(0,s.jsxs)(t.h5,{id:"consent_header-string",children:[(0,s.jsx)(t.code,{children:"consent_header"})," (string)"]}),"\n",(0,s.jsx)(t.p,{children:"The title of the consent prompt shown. Set automatically when the consent stage is used with a OAuth2, Proxy or SAML provider."}),"\n",(0,s.jsxs)(t.h5,{id:"consent_permissions-list-of-permissiondict",children:[(0,s.jsx)(t.code,{children:"consent_permissions"})," (List of PermissionDict)"]}),"\n",(0,s.jsx)(t.p,{children:"An optional list of all permissions that will be given to the application by granting consent. Not supported with SAML. When used with an OAuth2 or Proxy provider, this will be set based on the configured scopes."}),"\n",(0,s.jsx)(t.h4,{id:"deny-stage",children:"Deny stage"}),"\n",(0,s.jsxs)(t.h5,{id:"deny_message-string",children:[(0,s.jsx)(t.code,{children:"deny_message"})," (string)"]}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsx)(t.p,{children:"Requires authentik 2023.10"})}),"\n",(0,s.jsx)(t.p,{children:"Optionally overwrite the deny message shown, has a higher priority than the message configured in the stage."}),"\n",(0,s.jsx)(t.h4,{id:"user-write-stage",children:"User write stage"}),"\n",(0,s.jsxs)(t.h5,{id:"groups-list-of-group-objects",children:[(0,s.jsx)(t.code,{children:"groups"})," (List of ",(0,s.jsx)(t.a,{href:"/docs/user-group-role/groups/",children:"Group objects"}),")"]}),"\n",(0,s.jsxs)(t.p,{children:["See ",(0,s.jsx)(t.a,{href:"/docs/user-group-role/groups/",children:"Group"}),". If set in the flow context, the ",(0,s.jsx)(t.code,{children:"pending_user"})," will be added to all the groups in this list."]}),"\n",(0,s.jsx)(t.p,{children:"If set, this must be a list of group objects and not group names."}),"\n",(0,s.jsxs)(t.h5,{id:"user_path-string",children:[(0,s.jsx)(t.code,{children:"user_path"})," (string)"]}),"\n",(0,s.jsxs)(t.p,{children:["Path the ",(0,s.jsx)(t.code,{children:"pending_user"})," will be written to. If not set in the flow, falls back to the value set in the user_write stage, and otherwise to the ",(0,s.jsx)(t.code,{children:"users"})," path."]}),"\n",(0,s.jsxs)(t.h5,{id:"user_type-string",children:[(0,s.jsx)(t.code,{children:"user_type"})," (string)"]}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsx)(t.p,{children:"Requires authentik 2023.10"})}),"\n",(0,s.jsxs)(t.p,{children:["Type the ",(0,s.jsx)(t.code,{children:"pending_user"})," will be created as. Must be one of ",(0,s.jsx)(t.code,{children:"internal"}),", ",(0,s.jsx)(t.code,{children:"external"})," or ",(0,s.jsx)(t.code,{children:"service_account"}),"."]}),"\n",(0,s.jsx)(t.h4,{id:"password-stage",children:"Password stage"}),"\n",(0,s.jsxs)(t.h5,{id:"user_backend-string",children:[(0,s.jsx)(t.code,{children:"user_backend"})," (string)"]}),"\n",(0,s.jsxs)(t.p,{children:["Set by the ",(0,s.jsx)(t.a,{href:"/docs/flow/stages/password/",children:"Password stage"})," after successfully authenticating in the user. Contains a dot-notation to the authentication backend that was used to successfully authenticate the user."]}),"\n",(0,s.jsxs)(t.h5,{id:"auth_method-string",children:[(0,s.jsx)(t.code,{children:"auth_method"})," (string)"]}),"\n",(0,s.jsxs)(t.p,{children:["Set by the ",(0,s.jsx)(t.a,{href:"/docs/flow/stages/password/",children:"Password stage"}),", the ",(0,s.jsx)(t.a,{href:"/docs/flow/stages/authenticator_validate/",children:"Authenticator validation stage"}),", the ",(0,s.jsx)(t.a,{href:"/docs/providers/oauth2/",children:"OAuth2 Provider"}),", and the API authentication depending on which method was used to authenticate."]}),"\n",(0,s.jsx)(t.p,{children:"Possible options:"}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"password"})," (Authenticated via the password in authentik's database)"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"token"})," (Authenticated via API token)"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"ldap"})," (Authenticated via LDAP bind from an LDAP source)"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"auth_mfa"})," (Authentication via MFA device without password)"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"auth_webauthn_pwl"})," (Passwordless authentication via WebAuthn)"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"jwt"})," (",(0,s.jsx)(t.a,{href:"/docs/providers/oauth2/client_credentials",children:"M2M"})," authentication via an existing JWT)"]}),"\n"]}),"\n",(0,s.jsxs)(t.h5,{id:"auth_method_args-dictionary",children:[(0,s.jsx)(t.code,{children:"auth_method_args"})," (dictionary)"]}),"\n",(0,s.jsxs)(t.p,{children:["Additional arguments used during the authentication. Value varies depending on ",(0,s.jsx)(t.code,{children:"auth_method"}),"."]}),"\n",(0,s.jsx)(t.p,{children:"Example:"}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-json",children:'{\n    // List of the MFA device objects used during authentication\n    // applies for `auth_method` `auth_mfa`\n    "mfa_devices": [],\n    // MFA device used for passwordless authentication, applies to\n    // `auth_method` `auth_webauthn_pwl`\n    "device": null,\n    // the token identifier when `auth_method` `token` was used\n    "identifier": "",\n    // JWT information when `auth_method` `jwt` was used\n    "jwt": {},\n    "source": null,\n    "jwk_id": ""\n}\n'})}),"\n",(0,s.jsx)(t.h4,{id:"email-stage",children:"Email stage"}),"\n",(0,s.jsxs)(t.h5,{id:"email_sent-boolean",children:[(0,s.jsx)(t.code,{children:"email_sent"})," (boolean)"]}),"\n",(0,s.jsx)(t.p,{children:"Boolean set to true after the email form the email stage has been sent."}),"\n",(0,s.jsxs)(t.h5,{id:"email-string",children:[(0,s.jsx)(t.code,{children:"email"})," (string)"]}),"\n",(0,s.jsxs)(t.p,{children:["Optionally override the email address that the email will be sent to. If not set, defaults to the email of ",(0,s.jsx)(t.code,{children:"pending_user"}),"."]}),"\n",(0,s.jsx)(t.h4,{id:"identification-stage",children:"Identification stage"}),"\n",(0,s.jsxs)(t.h5,{id:"pending_user_identifier-string-1",children:[(0,s.jsx)(t.code,{children:"pending_user_identifier"})," (string)"]}),"\n",(0,s.jsxs)(t.p,{children:["If ",(0,s.jsx)(t.em,{children:"Show matched user"})," is disabled, this key will be set to the user identifier entered by the user in the identification stage."]})]})}function h(e={}){const{wrapper:t}={...(0,n.a)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(l,{...e})}):l(e)}}}]);