"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[26417],{31839:(e,s,i)=>{i.r(s),i.d(s,{assets:()=>l,contentTitle:()=>o,default:()=>c,frontMatter:()=>a,metadata:()=>r,toc:()=>d});var n=i(85893),t=i(11151);const a={title:"Overview"},o=void 0,r={id:"flow/index",title:"Overview",description:"Flows are a method of describing a sequence of stages. A stage represents a single verification or logic step. They are used to authenticate users, enroll them, and more.",source:"@site/docs/flow/index.md",sourceDirName:"flow",slug:"/flow/",permalink:"/docs/flow/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/flow/index.md",tags:[],version:"current",frontMatter:{title:"Overview"},sidebar:"docs",previous:{title:"Upgrading an Outpost",permalink:"/docs/outposts/upgrading"},next:{title:"Layouts",permalink:"/docs/flow/layouts"}},l={},d=[{value:"Permissions",id:"permissions",level:2},{value:"Denied action",id:"denied-action",level:3},{value:"Designation",id:"designation",level:2},{value:"Authentication",id:"authentication",level:4},{value:"Invalidation",id:"invalidation",level:4},{value:"Enrollment",id:"enrollment",level:4},{value:"Unenrollment",id:"unenrollment",level:4},{value:"Recovery",id:"recovery",level:4},{value:"Stage configuration",id:"stage-configuration",level:4},{value:"Import &amp; Export",id:"import--export",level:2},{value:"Behavior settings",id:"behavior-settings",level:2},{value:"Compatibility mode",id:"compatibility-mode",level:3}];function h(e){const s={a:"a",code:"code",h2:"h2",h3:"h3",h4:"h4",li:"li",p:"p",strong:"strong",ul:"ul",...(0,t.a)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(s.p,{children:"Flows are a method of describing a sequence of stages. A stage represents a single verification or logic step. They are used to authenticate users, enroll them, and more."}),"\n",(0,n.jsx)(s.p,{children:"For example, a standard login flow would consist of the following stages:"}),"\n",(0,n.jsxs)(s.ul,{children:["\n",(0,n.jsx)(s.li,{children:"Identification, user identifies themselves via a username or email address"}),"\n",(0,n.jsx)(s.li,{children:"Password, the user's password is checked against the hash in the database"}),"\n",(0,n.jsx)(s.li,{children:"Log the user in"}),"\n"]}),"\n",(0,n.jsxs)(s.p,{children:["Upon flow execution, a plan containing all stages is generated. This means that all attached policies are evaluated upon execution. This behaviour can be altered by enabling the ",(0,n.jsx)(s.strong,{children:"Evaluate when stage is run"})," option on the binding."]}),"\n",(0,n.jsxs)(s.p,{children:["The determine which flow should be used, authentik will first check which default authentication flow is configured in the active ",(0,n.jsx)(s.a,{href:"/docs/brands",children:(0,n.jsx)(s.strong,{children:"Brand"})}),". If no default is configured there, the policies in all flows with the matching designation are checked, and the first flow with matching policies sorted by ",(0,n.jsx)(s.code,{children:"slug"})," will be used."]}),"\n",(0,n.jsx)(s.h2,{id:"permissions",children:"Permissions"}),"\n",(0,n.jsx)(s.p,{children:"Flows can have policies assigned to them. These policies determine if the current user is allowed to see and use this flow."}),"\n",(0,n.jsx)(s.p,{children:"Keep in mind that in certain circumstances, policies cannot match against users and groups as there is no authenticated user yet."}),"\n",(0,n.jsx)(s.h3,{id:"denied-action",children:"Denied action"}),"\n",(0,n.jsxs)(s.p,{children:["Configure what happens when access to a flow is denied by a policy. By default, authentik will redirect to a ",(0,n.jsx)(s.code,{children:"?next"})," parameter if set, and otherwise show an error message."]}),"\n",(0,n.jsxs)(s.ul,{children:["\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"MESSAGE_CONTINUE"}),": Show a message if no ",(0,n.jsx)(s.code,{children:"?next"})," parameter is set, otherwise redirect."]}),"\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"MESSAGE"}),": Always show error message."]}),"\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"CONTINUE"}),": Always redirect, either to ",(0,n.jsx)(s.code,{children:"?next"})," if set, otherwise to the default interface."]}),"\n"]}),"\n",(0,n.jsx)(s.h2,{id:"designation",children:"Designation"}),"\n",(0,n.jsx)(s.p,{children:"Flows are designated for a single purpose. This designation changes when a flow is used. The following designations are available:"}),"\n",(0,n.jsx)(s.h4,{id:"authentication",children:"Authentication"}),"\n",(0,n.jsx)(s.p,{children:"This is designates a flow to be used for authentication."}),"\n",(0,n.jsxs)(s.p,{children:["The authentication flow should always contain a ",(0,n.jsx)(s.a,{href:"/docs/flow/stages/user_login/",children:(0,n.jsx)(s.strong,{children:"User Login"})})," stage, which attaches the staged user to the current session."]}),"\n",(0,n.jsx)(s.h4,{id:"invalidation",children:"Invalidation"}),"\n",(0,n.jsx)(s.p,{children:"This designates a flow to be used to invalidate a session."}),"\n",(0,n.jsxs)(s.p,{children:["This flow should always contain a ",(0,n.jsx)(s.a,{href:"/docs/flow/stages/user_logout",children:(0,n.jsx)(s.strong,{children:"User Logout"})})," stage, which resets the current session."]}),"\n",(0,n.jsx)(s.h4,{id:"enrollment",children:"Enrollment"}),"\n",(0,n.jsxs)(s.p,{children:["This designates a flow for enrollment. This flow can contain any amount of verification stages, such as ",(0,n.jsx)(s.a,{href:"stages/email/",children:(0,n.jsx)(s.strong,{children:"email"})})," or ",(0,n.jsx)(s.a,{href:"stages/captcha/",children:(0,n.jsx)(s.strong,{children:"captcha"})}),". At the end, to create the user, you can use the ",(0,n.jsx)(s.a,{href:"/docs/flow/stages/user_write",children:(0,n.jsx)(s.strong,{children:"user_write"})})," stage, which either updates the currently staged user, or if none exists, creates a new one."]}),"\n",(0,n.jsx)(s.h4,{id:"unenrollment",children:"Unenrollment"}),"\n",(0,n.jsxs)(s.p,{children:["This designates a flow for unenrollment. This flow can contain any amount of verification stages, such as ",(0,n.jsx)(s.a,{href:"stages/email/",children:(0,n.jsx)(s.strong,{children:"email"})})," or ",(0,n.jsx)(s.a,{href:"stages/captcha/",children:(0,n.jsx)(s.strong,{children:"captcha"})}),". As a final stage, to delete the account, use the ",(0,n.jsx)(s.a,{href:"/docs/flow/stages/user_delete",children:(0,n.jsx)(s.strong,{children:"user_delete"})})," stage."]}),"\n",(0,n.jsx)(s.h4,{id:"recovery",children:"Recovery"}),"\n",(0,n.jsxs)(s.p,{children:["This designates a flow for recovery. This flow normally contains an ",(0,n.jsx)(s.a,{href:"stages/identification/",children:(0,n.jsx)(s.strong,{children:"identification"})})," stage to find the user. It can also contain any amount of verification stages, such as ",(0,n.jsx)(s.a,{href:"stages/email/",children:(0,n.jsx)(s.strong,{children:"email"})})," or ",(0,n.jsx)(s.a,{href:"stages/captcha/",children:(0,n.jsx)(s.strong,{children:"captcha"})}),".\nAfterwards, use the ",(0,n.jsx)(s.a,{href:"stages/prompt/",children:(0,n.jsx)(s.strong,{children:"prompt"})})," stage to ask the user for a new password and the ",(0,n.jsx)(s.a,{href:"/docs/flow/stages/user_write",children:(0,n.jsx)(s.strong,{children:"user_write"})})," stage to update the password."]}),"\n",(0,n.jsx)(s.h4,{id:"stage-configuration",children:"Stage configuration"}),"\n",(0,n.jsx)(s.p,{children:"This designates a flow for general setup. This designation doesn't have any constraints in what you can do. For example, by default this designation is used to configure Factors, like change a password and setup TOTP."}),"\n",(0,n.jsx)(s.h2,{id:"import--export",children:"Import & Export"}),"\n",(0,n.jsx)(s.p,{children:"Flows can be imported and exported to share with other people, the community and for troubleshooting. Flows can be imported to apply new functionality and apply existing workflows."}),"\n",(0,n.jsxs)(s.p,{children:["Download our ",(0,n.jsx)(s.a,{href:"/docs/flow/examples/flows",children:"Example flows"})," and then import them into your authentik instance."]}),"\n",(0,n.jsx)(s.p,{children:"Starting with authentik 2022.8, flows will be exported as YAML, but JSON-based flows can still be imported."}),"\n",(0,n.jsx)(s.h2,{id:"behavior-settings",children:"Behavior settings"}),"\n",(0,n.jsx)(s.h3,{id:"compatibility-mode",children:"Compatibility mode"}),"\n",(0,n.jsxs)(s.p,{children:["The compatibility mode increases compatibility with password managers. Password managers like ",(0,n.jsx)(s.a,{href:"https://1password.com/",children:"1Password"})," for example don't need this setting to be enabled, when accessing the flow from a desktop browser. However accessing the flow from a mobile device might necessitate this setting to be enabled."]}),"\n",(0,n.jsxs)(s.p,{children:["The technical reasons for this settings' existence is due to the JavaScript libraries we're using for the default flow interface. These interfaces are implemented using ",(0,n.jsx)(s.a,{href:"https://lit.dev/",children:"Lit"}),", which is a modern web development library. It uses a web standard called ",(0,n.jsx)(s.a,{href:"https://developer.mozilla.org/en-US/docs/Web/API/Web_components/Using_shadow_DOM",children:'"Shadow DOMs"'}),", which makes encapsulating styles simpler. Due to differences in Browser APIs, many password managers are not compatible with this technology."]}),"\n",(0,n.jsx)(s.p,{children:"When the compatibility mode is enabled, authentik uses a polyfill which emulates the Shadow DOM APIs without actually using the feature, and instead a traditional DOM is rendered. This increases support for password managers, especially on mobile devices."})]})}function c(e={}){const{wrapper:s}={...(0,t.a)(),...e.components};return s?(0,n.jsx)(s,{...e,children:(0,n.jsx)(h,{...e})}):h(e)}}}]);